# Parts

  * Client - Raspberry Pi 
  * Server
    * Admin - web application for managing patients and to see logs
    * Checker - application for cooperating with firebase (database)
    * Executor - dialog manager
  * Database - Firebase
  
# Development instruction

  See [install script of client](./client/install.sh)
      

# Instruction to install on new device

  * Install [Raspbian Stretch with desktop and recommended software](https://www.raspberrypi.org/downloads/raspbian/) on the MicroSD card (was used Etcher (macOS)) 
    * Has to be version 2019-04-08-raspbian-stretch-full.img, which can be connected to Eduoram (newer one was [not working](https://www.raspberrypi.org/forums/viewtopic.php?t=235105) with Eduoram)
    * Set wifi to connect in [headless mode](https://www.raspberrypi.org/forums/viewtopic.php?p=1262306&sid=bfd3bb7d8d2a2ff2f5174dcb85f24097#p1262306)
      * Remove and insert MicroSD card After flashing the Raspbian on it
      * Create a file ssh on the SD card
            
            MacOS: touch /Volumes/boot/ssh
            
      * Create a file wpa_supplicant.conf with content below:
            
         * For MacOS: 
       
               vim /Volumes/boot/wpa_supplicant.conf
            
         * Insert code below
         
                ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev
                update_config=1
                country=CZ
                
                network={
                     ssid="Your network name/SSID"
                     psk="Your WPA/WPA2 security key"
                     key_mgmt=WPA-PSK
                }
         * For eduoram
         
               ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev
               update_config=1
               country=CZ
               
               network={
                   ssid="eduroam"
                   key_mgmt=WPA-EAP
                   eap=PEAP
                   identity="username@cvut.cz"
                   password="Your WPA/WPA2 eduoram key"
                   phase2="auth=MSCHAPV2"
               }
   
    * Copy install.sh to raspberry
    
          mkdir /Volumes/boot/install_script
          cp ./install.sh /Volumes/boot/install_script/install.sh
            

# Generating unique ID

    import string; import random
    def id_generator(size=6, chars=string.ascii_uppercase):
        return ''.join(random.choice(chars) for _ in range(size))
    
    print(id_generator(25, chars=string.ascii_lowercase + string.ascii_uppercase + string.digits))
    
# Build docker image and push him to repository

    docker login gitlab.promethist.ai
    docker build -t registry.promethist.ai/platform/brainquist/app:develop client/app
    docker push registry.promethist.ai/platform/brainquist/app:develop
    
# Useful commands

    alsamixer - for sound level
    arecord --format=S16_LE --duration=5 --rate=16000 --file-type=wav out.wav
    journalctl -u service-name.service
    ssh-keygen -R 192.168.1.121


.